Dependency injector with support async init

A simple usage example

    import 'package:async_injector/async_injector.dart';

    class DI {
      static Provider instance;

      static initComponent() async {
        var builder = ProviderBuilder();
        //preference
        builder
          ..moduleImpl((_) => SharedPreferences.getInstance())
          ..moduleImpl((provider) => PreferenceImpl(provider.get()));
        //api
        builder
          ..moduleImpl((provider) => AuthInterceptor(provider.get()))
          ..module(DioModule());

        DI.instance = await builder.build();
      }

      static T get<T>() => instance.get<T>();

    }

After build use get method by request type

    SharedPreferences preference = DI.get()

You can return Future to the module and the result from it is added to the area
    
     ..moduleImpl((provider) => SharedPreferences.getInstance())
     
If need to provide super class from value, set this class in type

      ..moduleImpl<ApiGateway>((provider) => ApiGatewayImpl(provider.get()))